/* Copyright (c) 2002 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor menu.c */

#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include "strukturyw.h"
#include "struktury.h"
#include "libw.h"
#include "lib.h"
#include "barvy.h"
#include "windows.h"
#include "menu.h"

menupolozka option[OPT] = {
    /* {"&Lekce 01-10", 'l', m_lekce, e_lekce0}, */
    /* {"&Testy 01-07", 't', m_test, e_test0}, */
    /* prvnich 12 se inicializuje ve funkci nacti_vyber_lt() */
    {"??????????", ' ', NULL, e_null}
    ,
    {NULL, ' ', NULL, e_null}
    ,
    {NULL, ' ', NULL, e_null}
    ,
    {NULL, ' ', NULL, e_null}
    ,
    {NULL, ' ', NULL, e_null}
    ,
    {NULL, ' ', NULL, e_null}
    ,
    {NULL, ' ', NULL, e_null}
    ,
    {NULL, ' ', NULL, e_null}
    ,
    {NULL, ' ', NULL, e_null}
    ,
    {NULL, ' ', NULL, e_null}
    ,
    {NULL, ' ', NULL, e_null}
    ,
    {NULL, ' ', NULL, e_null}
    ,
    {"V&sledky", 's', NULL, e_vysledky}
    ,
    {NULL, ' ', NULL, e_null}
    ,
    {"Kl&vesnice (F2)", 'v', NULL, e_klavesnice}
    ,
    {NULL, ' ', NULL, e_null}
    ,
    {"&Metronom", 'm', NULL, e_metronom}
    ,
    {"Nastav&en kl.", 'e', NULL, e_qwertz}
    ,
    {"N&astaven v.t.", 'a', NULL, e_nastavenivt}
    ,
    {NULL, ' ', NULL, e_null}
    ,
    {"&Jmno:", 'j', m_jmeno, e_jmeno}
    ,
    {"Nov &heslo:", 'h', m_heslo, e_heslo}
    ,
#ifdef PSANIPROFI
    {"&Zamknout (F11)", 'z', NULL, e_lock}
    ,
#else
    {NULL, ' ', NULL, e_null}
    ,
#endif
    {NULL, ' ', NULL, e_null}
    ,
    /* druhych 12; */
    {"&Npovda (F1)", 'n', NULL, e_napoveda}
    ,
    {"O &programu", 'p', NULL, e_copyright}
    ,
    {NULL, ' ', NULL, e_null}
    ,
    {NULL, ' ', NULL, e_null}
    ,
    {NULL, ' ', NULL, e_null}
    ,
    {NULL, ' ', NULL, e_null}
    ,
    {NULL, ' ', NULL, e_null}
    ,
    {NULL, ' ', NULL, e_null}
    ,
    {NULL, ' ', NULL, e_null}
    ,
    {NULL, ' ', NULL, e_null}
    ,
    {"&Konec (F10)", 'k', NULL, e_konec}
    ,
    /* musi jich byt celkem OPT, */
    /* posledni by nemel byt "" ! */
};

/*---------------------------------------------------------------------------*/
enum_menu menu(type_uziv * slozka, type_nastaveni * nastaveni,
               enum_menu men)
{
    int i, ch, radka;
    int sloupec;

    wattron2(sub_hlavni, COLOR_PAIR(COLOR_MENU_HLAVNI));

    radka = 0;
    for (i = 0; i < OPT; i++)
        if (men == option[i].navrat) {
            radka = i;
            break;
        }

    do {
      novyradek:
        sloupec = 0;
#ifndef PSANIPROFI
        werase2(sub_hlavni);
        werase2(sub_informace);
#else
        vymaz_okno(sub_hlavni);
        vymaz_okno(sub_informace);
#endif
        wattron2(sub_hlavni, COLOR_PAIR(COLOR_ZNACEK_HLAVNI) | A_BOLD);
        znacek(sub_hlavni, 4, 45);      /*,COLS - 35); */
        wattron2(sub_hlavni, COLOR_PAIR(COLOR_MENU_HLAVNI));
        wattroff2(sub_hlavni, A_BOLD);

        for (i = 0; i < OPT; i++) {
            if (!(i % POCRADEK) && i)
                sloupec++;

            wmove2(sub_hlavni, POS + i - sloupec * POCRADEK,
                   5 + (sloupec * POS2));
            if (radka == i)
                print_menu(option[i].opt, 1);
            else
                print_menu(option[i].opt, 0);
        }
/****************************************************************************/

        if (option[radka].fce != NULL) {
            i = option[radka].fce(radka, slozka, nastaveni);
            if (i) {
                radka = i;
                goto novyradek;
            }
        }

        obnov_hlavni();
        tiskni_dle_priority();
/*****************************************************************************/
        ch = getch3();

        if (ch != ' ') {
            if ((ch < 'A') || (ch > 'Z')) {
                for (i = radka + 1; i < OPT; i++) {
                    if (ch == option[i].ch) {
                        radka = i;
                        goto novyradek;
                    }
                }

                for (i = 0; i < radka; i++) {
                    if (ch == option[i].ch) {
                        radka = i;
                        goto novyradek;
                    }
                }
            } else {
                ch += ('a' - 'A');
                for (i = radka - 1; i >= 0; i--) {
                    if (ch == option[i].ch) {
                        radka = i;
                        goto novyradek;
                    }
                }

                for (i = OPT - 1; i > radka; i--) {
                    if (ch == option[i].ch) {
                        radka = i;
                        goto novyradek;
                    }
                }
            }
        }
/******************************************************************************/
        if (ch == KEY_DOWN) {
            if (radka < OPT - 1) {
                do {
                    radka++;
                }
                while (!option[radka].opt);
            } else
                radka = 0;
        } else if (ch == KEY_UP) {
            if (radka > 0)
                do {
                    radka--;
                }
                while (!option[radka].opt);
            else
                radka = OPT - 1;
        }
    }
    while (ch != '\n');

    return option[radka].navrat;
}

/*------------------------------------------------------------------------*/

void print_menu(char *option, int BOLD)
{
    int i = 0;
    int bold = 0;
    char stemp[POS2 + 1];

    if (option == NULL)
        return;

    if (BOLD) {
        bold = 1;
        wattron2(sub_hlavni, /* A_BOLD | */ A_REVERSE);
    }

    while (option[i] && (i < POS2)) {
        switch (option[i]) {
        case '&':
            if (!BOLD) {
                bold = 2;
                wattron2(sub_hlavni, A_BOLD);
            }
            break;
        default:
            sprintf(stemp, "%c", option[i]);
            wprintw2(sub_hlavni, stemp);
            break;
        }

        if (bold && !BOLD) {
            if (bold == 2) {
                bold = 1;
            } else {
                bold = 0;
                wattroff2(sub_hlavni, A_BOLD);
            }
        }
        i++;
    }
    /* doplneni mezer v menu u kratkych nazvu polozek */
    if ((POS2 - 4 - i) > 0) {
        sprintf(stemp, "%*c", POS2 - 4 - i, ' ');
        wprintw2(sub_hlavni, stemp);
    }
    if (BOLD)
        wattroff2(sub_hlavni, /* A_BOLD | */ A_REVERSE);
}
